    # File lib/active_record/connection_adapters/abstract/schema_statements.rb, line 270
          def add_index(table_name, column_name, options = {})
            column_names = Array(column_name)
            index_name   = index_name(table_name, :column => column_names)

            if Hash === options # legacy support, since this param was a string
              index_type = options[:unique] ? "UNIQUE" : ""
              index_name = options[:name] || index_name
            else
              index_type = options
            end

            if index_name.length > index_name_length
              @logger.warn("Index name '#{index_name}' on table '#{table_name}' is too long; the limit is #{index_name_length} characters. Skipping.")
              return
            end
            if index_exists?(table_name, index_name, false)
              @logger.warn("Index name '#{index_name}' on table '#{table_name}' already exists. Skipping.")
              return
            end
            quoted_column_names = quoted_columns_for_index(column_names, options).join(", ")

            execute "CREATE #{index_type} INDEX #{quote_column_name(index_name)} ON #{quote_table_name(table_name)} (#{quoted_column_names})"
          end